 
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#if defined(OS_LINUX) || defined(OS_MACOSX)
#include <sys/ioctl.h>
#include <termios.h>
#elif defined(OS_WINDOWS)
#include <conio.h>
#endif


#include "hid.h"
void set_inargs(char**);
int get_P_value(char**);
int set_output(int p);
void getbits(int c,char** a);
void printusage(void);
int verbose;
typedef enum
{
    ERROR,
    PTYPE,
    BTYPE
} ARGIN ;

typedef enum
{
    COMMAND_GET_BUTTON_STATUS = 0x81,   //BUTTON
    COMMAND_READ_POTENTIOMETER = 0x37,  //POT
    COMMAND_ASSIGN_PORTS =0x82,         //PROGRAM_DIGITAL
    COMMAND_ASSIGN_AD =0x83,            //PROGRAM_AD
    COMMAND_SET_PORT =0x84,             //SET
    COMMAND_CLR_PORT =0x85,             //CLEAR
    COMMAND_TOGGLE_PORT = 0x86,         //TOGGLE
    COMMAND_GET_PORT =0x87              //GET
            
} CUSTOM_HID_DEMO_COMMANDS;


char buf[9];  // was 64
//unsigned int InArg1,InArg2,InArg3,InArg4,InArg5,InArg6,InArg7,InArg8;   
   

int main( int argc, char *argv[] )
{
    int  i , r ,num, get=1 ,delay, count=0; //Mycounter=0; m='0'
    unsigned int chksum=0;
    //printf("\n 001 \n",argc);
    verbose=0;
    
    // Clear buffers
    for (i=1; i<8; i++) {
		buf[i] = 0;
	}

    if ( argc == 1  ) 
    {
        printusage();
        return -1;
    }
    if ( argc > 32  ) /* argc should be 10 for correct execution */
    {
        printf("\nError - arguments incorrect \n");
        return -1;
    }     
    
    if (!strcmp(argv[1], "PROGRAM_DIG") || !strcmp(argv[1], "program_dig"))  
    {
        buf[0]=COMMAND_ASSIGN_PORTS;  
        if (argc>2) 
            getbits(argc,argv);
        //else  Set all as inputs
               
    }
    else if (!strcmp(argv[1], "SET") || !strcmp(argv[1], "set")) 
    {
        buf[0]=COMMAND_SET_PORT;          
        getbits(argc,argv);
        //printf("\nSET OK  \n");
    }
    else if (!strcmp(argv[1], "CLEAR") || !strcmp(argv[1], "clear")) 
    {
        buf[0]=COMMAND_CLR_PORT;          
        getbits(argc,argv);
        //printf("\nCLEAR OK  \n");
    }
    else if (!strcmp(argv[1], "TOGGLE") || !strcmp(argv[1], "toggle")) 
    {
        buf[0]=COMMAND_TOGGLE_PORT;  
        getbits(argc,argv);
        //printf("\nTOGGLE OK  \n");
    }     
    else if (!strcmp(argv[1], "GET") || !strcmp(argv[1], "get")) 
    {
        buf[0]=COMMAND_GET_PORT;   
        if (!strcmp(argv[2], "BYTES")) buf[1]=1;
        else if (!strcmp(argv[2], "PORTS")) buf[1]=2;   
        else if (!strcmp(argv[2], "BOTH")) buf[1]=3;   
        else printf("\nSwitch Error only BYTES,PORTS or BOTH\n");
        get=buf[1];
        
    }
    else if (!strcmp(argv[1], "DEBUG")|| !strcmp(argv[1], "debug"))   
    {
        verbose=1;
        buf[0]=COMMAND_TOGGLE_PORT;  
        getbits(argc,argv);
    } 
    else
    {
        //printf("\nINVALID COMMAND  \n");
    }
    
    
    
    
    
        //printf("Command= %x \n" ,(buf[0]&0xff));
        //printf("Buf[1]= %x \n" ,(buf[1]&0xff));
        //printf("Buf[2]= %x \n" ,(buf[2]&0xff));
        //printf("Buf[3]= %x \n" ,(buf[3]&0xff));
        //printf("Buf[4]= %x \n" ,(buf[4]&0xff));
        //printf("Buf[5]= %x \n" ,(buf[5]&0xff));
        //printf("Buf[6]= %x \n" ,(buf[6]&0xff));
        //printf("Buf[7]= %x \n" ,(buf[7]&0xff));
        //printf("Buf[8]= %x \n" ,(buf[8]&0xff));   
    
	// C-based example is 16C0:0480:FFAB:0200
	//r = rawhid_open(1, 0x16C0, 0x0480, 0xFFAB, 0x0200);
    r = rawhid_open(verbose,100, 0x5888, 0x0003, 0xFF00, 0x01);
	if (r <= 0) {
        printf("\n No usb device found - try unpluging cable and reconnecting or run DEBUG\n");
        return -1;
	}
 
   
    while(count++<3)
    {
    

            // Calculate Checksum
            chksum=0xFF;
            for (i=0; i<=4; i++) {
                chksum-=(buf[i]);
            }
            chksum=chksum&0xFF;
            rawhid_send(0, buf, 8, 100);  // was 64
            //printf("\nSent chk %x \n",chksum);
        
        
        
        delay=0;
        while (delay++ < 4)
        {
            
               
            // check if any Raw HID packet has arrived
            num = rawhid_recv(verbose,0, buf, 8, 220);  // was 64
            if (num < 0) {
                printf("\nerror reading, device went offline\n");
    			rawhid_close(0);
        		return 0;
            }
            if (num > 0) {
                
                //printf("\nrecv %d bytes:\n", num);
                //for (i=0; i<num; i++) {
    			// printf("%02X ", buf[i] & 255);
    			//	if (i % 16 == 15 && i < num-1) printf("\n");
    			//}
                //printf("\n");
                
                //printf("Buf[0]= %x \n" ,(buf[0]&0xff));
                //printf("Buf[1]= %x \n" ,(buf[1]&0xff));
                //printf("Buf[2]= %x \n" ,(buf[2]&0xff));
 
                if (((buf[0]&0xff)==COMMAND_GET_PORT) && ((buf[1]&0xff) == chksum) && ((buf[2]&0xff) == 0xaa))
                {
                    if (get&1){
                        
                       for (i=3;i<7;i++)
                       {
                        printf("%x",buf[i]&0xff);
                        printf(" ");
                       }                          
                    }
                    /*if  (get&2) {                     
                       
                       if (get&1)  printf("\n");
                       for (i=8;i<13;i++)
                       {
                        printf("%x",buf[i]&0xff);
                        printf(" ");
                       }  
                    }
                      */

                }
                return 0;
                //printf("\nBye!\n");
                
            }        
			//printf("\n Delay=%d\n",delay);
		}
    
    }   

    
     return -1;
     //printf("\nBye!\n");
	 
 } // end main

int set_output(int p)
{
    if (p<=8)   buf[4]|=1<<(p-1);
    else 
    {
        if (p<=16)  buf[3]|=1<<(p-9);
        else 
        {     if (p<=24) buf[2]|=1<<(p-17);
              else 
              {    if (p<=32) buf[1]|=1<<(p-25);
                   else return 0;
              }
        }
    } 
    return 1;
}

int get_P_value(char** a)
{
int i=2,p=0;
int match=0;
        while (a[i] != 0)
        {
            if (a[i][0]=='P' || a[i][0]=='p')
            {
                if (a[i][2] == 0)
                {
                    p=a[i][1]-48;
                }
                else
                {
                    if (a[i][1] == '1') p=10+(a[i][2]-48); 
                    else if (a[i][1] == '2') p=20+(a[i][2]-48); 
                    else if (a[i][1] == '3') p=30; 
                }
                //printf("Match %d \n" ,p);
                if(set_output(p)>0)  match=1; 
            }
            else
            {
              return 0;  
            }
            i++;      
        }
    return match;     
}
void set_inargs(char** a)
{                 
        // 4 Byte input
        buf[1] = (int)strtol(a[2], NULL, 16);
        buf[2] = (int)strtol(a[3], NULL, 16);
        buf[3] = (int)strtol(a[4], NULL, 16);
        buf[4] = (int)strtol(a[5], NULL, 16);      
}

void getbits(int c,char** a){
       //printf("\ngetbits \n");  
        // Get arguments and set Buffers1 to 4 for OUTPUTS that are to be set   
        if(get_P_value(a)>0){
             //printf("\nP GOOD \n"); 
        } 
        else{
             //printf("\nc=%d\n",c);  
             if(c==6){
                 set_inargs(a);
                 //printf("\nB GOOD\n");      
             }
             else {
                printf("\nError - arguments incorrect2 \n");
             }
        }
        
}   

void printusage(void){
printf("\nsetio for XP30 usage:\n\n");    
printf("  setio <command> <Px> <Py>...    \n");
printf("\nor\n\n");
printf("  setio <command> <BYTE1> <BYTE2> <BYTE3> <BYTE4>\n");
printf("\nwhere\n\n");
printf("  <command> = PROGRAM_DIG,TOGGLE,SET,CLEAR,GET,DEBUG \n");
printf("  Px,Py     = P1 to P30\n");
printf("  BYTE1..4  = XX hex\n\n");
}


#if defined(OS_LINUX) || defined(OS_MACOSX)
// Linux (POSIX) implementation of _kbhit().
// Morgan McGuire, morgan@cs.brown.edu
static int _kbhit() {
	static const int STDIN = 0;
	static int initialized = 0;
	int bytesWaiting;

	if (!initialized) {
		// Use termios to turn off line buffering
		struct termios term;
		tcgetattr(STDIN, &term);
		term.c_lflag &= ~ICANON;
		tcsetattr(STDIN, TCSANOW, &term);
		setbuf(stdin, NULL);
		initialized = 1;
	}
	ioctl(STDIN, FIONREAD, &bytesWaiting);
	return bytesWaiting;
}
static char _getch(void) {
	char c;
	if (fread(&c, 1, 1, stdin) < 1) return 0;
	return c;
}
#endif




